Redmine - Defect #21742

Received text attachments doesn’t hold the original encoding on Ruby >= 2.1

2016-01-17 18:44 - Pavel Rosicky

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Email receiving Estimated time: 0.00 hour
Target version: 3.3.0

Resolution: Affected version:

Description

Hello,

if | send an email with .txt file encoded in ISO 8859-2, it's received from the mailbox and saved to /files, but the encoding is different
(some characters are lost). | think this is originaly caused by the utf-8 header added by email clients. In my opinion attachments

shouln't be reencoded. Am | missed somethig?
Attached patch fixes the issue.
Content-Type: text/plain;

charset=utf-8
Content-Transfer-Encoding: base64

Environment:
Redmine version 3.2.0
Ruby version 2.1.5-p273
Rails version 4.2.5
Environment production
Database adapter Mysqgl2
SCM:
Subversion 1.8.13
Git 1.9.5
Filesystem

Redmine plugins:
no plugin installed

.devel.15058
(2014-11-13) [1386-mingw32]

Associated revisions

Revision 15183 - 2016-03-04 07:55 - Toshi MARUYAMA

add test which ensure received mail text attachment keeps original encoding (#21742)

This test fails on Ruby >= 2.1 and will be fixed by next revision.

Contributed by Pavel Rosicky.

Revision 15184 - 2016-03-04 07:56 - Toshi MARUYAMA

fix received mail text attachment does not keep original encoding on Ruby >= 2.1 (#21742)

Contributed by Pavel Rosicky.

Revision 15185 - 2016-03-04 07:59 - Toshi MARUYAMA

svn propset svn:eol-style native fixture (#21742)

History

#1 - 2016-01-17 23:55 - Toshi MARUYAMA

- Status changed from New to Needs feedback

Could you add test?

e source:tags/3.2.0/test/unit/mail_handler_test.rb#L 563

e source:tags/3.2.0/test/fixtures/mail_handler/gmail_with_attachment_is0-8859-1.eml

2025-05-17

1/3



https://www.redmine.org/projects/redmine/repository/svn/entry/tags/3.2.0/test/unit/mail_handler_test.rb#L563
https://www.redmine.org/projects/redmine/repository/svn/entry/tags/3.2.0/test/fixtures/mail_handler/gmail_with_attachment_iso-8859-1.eml

#2 - 2016-01-18 11:55 - Pavel Rosicky
- File mail_handler_test.rb.patch added

Done

#3 - 2016-01-18 11:56 - Pavel Rosicky
- File ticket_with_text_attachment_iso-8859-2.eml.patch added

#4 - 2016-02-08 09:40 - Toshi MARUYAMA

| cannot reproduce on trunk r15148 with ruby-1.9.3-p551.
Test passes without mail_handler.rb.patch .
You can see latin2 encoded file in files/ directory with following change.

diff --git a/app/models/attachment.rb b/app/models/attachment.rb

—--— a/app/models/attachment.rb

+++ b/app/models/attachment.rb

@@ -53,7 +53,7 Q@ class Attachment < ActiveRecord::Base
@@thumbnails_storage_path = File.join(Rails.root, "tmp", "thumbnails")

before_create :files_to_final_location

- after_rollback :delete_from_disk, :on => :create

+ # after_rollback :delete_from_disk, :on => :create
after_commit :delete_from_disk, :on => :destroy

# Returns an unsaved copy of the attachment

$ ruby test/unit/mail_handler_test.rb -n test_mail_with_attachment_latin2
Run options: -n test_mail_with_attachment_latin2 --seed 14783

# Running:

Finished in 2.025752s, 0.4936 runs/s, 3.4555 assertions/s.

1 runs, 7 assertions, 0 failures, 0 errors, 0 skips

$ cat files/2016/02/160208173558_yourfile.txt | iconv -f latin2 -t utf8
ptilis Zluoucky kun

#5 - 2016-02-08 10:49 - Pavel Rosicky

- File encoded.txt added

- File original.txt added

retested against revision r15148 without mail_handler.rb.patch

MailHandlerTest#test_mail_with_attachment_latin2 [C:/redmine svn/test/unit/mail_handler_test.rb:590]:

Expected: 19
Actual: 12

About your application's environment

Rails version 4.25.1

Ruby version 2.1.5-p273 (x64-mingw32)

RubyGems version 2.2.3

Rack version 1.6.4

Middleware Rack::Sendfile, ActionDispatch::Static, Rack::Lock, #<

ActiveSupport::Cache::Strategy::LocalCache::Middleware:0x000000094378e0>, Rack::
Runtime, Rack::MethodOverride, ActionDispatch::Requestld, Rails::Rack::Logger, A
ctionDispatch::ShowExceptions, ActionDispatch::DebugExceptions, ActionDispatch::
Remotelp, ActionDispatch::Reloader, ActionDispatch::Callbacks, ActiveRecord::Con
nectionAdapters::ConnectionManagement, ActiveRecord::QueryCache, ActionDispatch:
:Cookies, ActionDispatch::Session::CookieStore, ActionDispatch::Flash, ActionDis
patch::ParamsParser, ActionDispatch::XmIParamsParser, Rack::Head, Rack::Conditio
nalGet, Rack::ETag, Rack::ContentLength, RequestStore::Middleware, OpenldAuthent
ication

Application root C:/redmine svn
Environment development
Database adapter mysql2

Database schema version 20151031095005
https://www.redmine.org/projects/redmine/repository/svn/revisions/15148
https://www.redmine.org/attachments/14995
https://www.redmine.org/projects/redmine/repository/svn/revisions/15148

Environment:

Redmine version 3.2.0.devel

Ruby version 2.1.5-p273 (2014-11-13) [x64-mingw32]
Rails version 4251

Environment production

Database adapter Mysql2

SCM:

Git 1.9.5

Filesystem

Redmine plugins:
no plugin installed

no other tests are failing (except IssueNestedSetConcurrencyTest which supposed to be a known problem on mysqgl) and with mail_handler.rb.patch

applied this one passes as well.

IssueNestedSetConcurrencyTest#test_concurrency [C:/redmine svn/test/unit/issue_nested_set_concurrency_test.rb:45]:

Expected "Mysql2::Error: Deadlock found when trying to get lock; try restarting

transaction: SELECT “issues’.’id” FROM “issues” WHERE (root_id IN (SELECT root_i

d FROM issues WHERE id IN (800,794))) ORDER BY ‘issues’.’id" ASC FOR UPDATE" to

be nil.

| attached both attachments, the original and the one saved to files (encoded.ixt). Maybe it depends on the environment, I'll try to find out.

#6 - 2016-02-09 00:38 - Pavel Rosicky

toshio harita MARUYAMA - could you retest it on a more recent Ruby version?

passed - ruby 1.9.3p551 (2014-11-13) [i386-mingw32]
failed - ruby 2.1.5p273 (2014-11-13 revision 48405) [i386-mingw32]
failed - ruby 2.2.3p173 (2015-08-18 revision 51636) [x64-mingw32]

failed - jruby 9.0.5.0-SNAPSHOT (2.2.3) 2016-01-20 775b79d Java HotSpot(TM) 64-Bit Server

#7 - 2016-03-04 07:46 - Toshi MARUYAMA

- Target version set to 3.3.0

#8 - 2016-03-04 07:47 - Toshi MARUYAMA

- Tracker changed from Patch to Defect

- Subject changed from Received text attachments doesn't hold the original encoding to Received text attachments doesn't hold the original encoding

on Ruby >= 2.1

- Status changed from Needs feedback to New

#9 - 2016-03-04 08:43 - Toshi MARUYAMA

- Status changed from New to Closed

Committed in trunk, thanks.
| have reported to upstream.
https://github.com/mikel/mail/issues/972

Files

mail_handler.rb.patch

mail_handler_test.rb.patch
ticket_with_text_attachment_iso-8859-2.eml.patch
original.txt

encoded.txt

2025-05-17

639 Bytes
1.15 KB
1.2 KB

19 Bytes
12 Bytes

2016-01-17
2016-01-18
2016-01-18
2016-02-08
2016-02-08

Pavel Rosicky
Pavel Rosicky
Pavel Rosicky
Pavel Rosicky

Pavel Rosicky
https://www.redmine.org/users/10651
https://github.com/mikel/mail/issues/972
http://www.tcpdf.org

